<?php

/* ***************************************************************************

  This is sell_book.php, the PHP file that handles new book sells

  It can only be used by users that are logged in. Normally, this page is
  the page displayed after the user has entered (or selected) the book
  information using enter_book.php ... it is sent an ISBN number via HTTP
  GET protocol, and checks for the correctness of this number fisrt. If the
  number is not good we redirect to enter_book.php, otherwise display a
  form where the user chooses the condition of the book from a list and
  enters the initial and reserve prices (minimum is 1 pound) as well as
  the sell duration (maximum is 30 days). The book is then added for sell.

  Note that a user can sell a same book many times... We thought that
  this may be possible in some cases, and anyways if the user has done
  something wrong can stop the sell at any time!

  When called directly, this file will redirect back to the index page

**************************************************************************** */

// PHP should only report big problems
error_reporting(E_ERROR);

// Page has been called, but not by our script !!
if(bath!="university")
{
  header("Location: index.php");
  die();
}

// Read ISBN number sent via HTTP GET
$isbn = $isbn = intval_10d($_GET['isbn']);

//-- SQL
$query = <<<ENDOFSTRING
SELECT `Title` FROM $booksT WHERE `ISBN` = $isbn;
ENDOFSTRING;
//-- ENDSQL
$result = $db->query($query);

if (!DB::isError($result) && $result->numRows()!=0)
{
  // Book found... Did the user submit a form?
  $ip = intval(read_p("form_init_p",0)/10);
  $rp = intval(read_p("form_res_p",0)/10);
  $num_days = read_p("form_days",0);
  $c = read_p("form_cond",32);

  if($ip>9 && $rp>9 && $num_days>0 && $num_days<31)
  {
    // Yes, it has... Insert data
    // We actually have 86400 seconds in one day
    $t2=$t+$num_days*86400;

//-- SQL
$query = <<<ENDOFSTRING
INSERT INTO $sellsT
(`BUCS_id`, `ISBN`, `Condition`, `Reserve_price`, `Initial_price`, `Date_started`, `Date_ending`) VALUES
("$user_id", $isbn, "$c", $rp, $ip, $t, $t2);
ENDOFSTRING;
//-- ENDSQL

    $db->query($query);

//-- SQL
$query = <<<ENDOFSTRING
SELECT `Sell_id` FROM $sellsT
WHERE `Date_started` = $t AND `Date_ending` = $t2 LIMIT 1;
ENDOFSTRING;
//-- ENDSQL

    $sell_id=$db->query($query);

    if(!DB::isError($sell_id) && ($sell_id->numRows())>0)
    {
      // Book inserted... Read information
      $sell_id=$sell_id->fetchRow(DB_FETCHMODE_ORDERED);
      $sell_id=$sell_id[0];

      echo "
      <table cellpadding='1' cellspacing='0'> 
      <tr> 
      <td align='center' valign='middle' class='Form_Cadre_title'>Here are the details for the book you are now selling: </td>
      <tr>
      <td class='Form_Cadre_main' align='center'>
      <br>";

      include("view_book.php");

      echo "
      <br>
      </td>
      </tr>
      </table>
      <br>
      <a href=index.php?do=main&sess_id=$sess_id>Click here</a> to go to the main page.<br>";
    }
    else
    {
      // That should not happen
      echo "Error inserting data";
    }
  }
  else
  {
  // No sell data submitted: ask for the sale details...

//-- SQL
$query = <<<ENDOFSTRING
DESCRIBE $sellsT `Condition`
ENDOFSTRING;
//-- ENDSQL

    $columns = $db->query($query);
    if(!DB::isError($columns) && ($columns->numRows())>0){
      // Get subjects list
      $columns=$columns->fetchRow(DB_FETCHMODE_ORDERED);
      $columns=explode("'",$columns[1]);
      $col_list=array();
      for($i=1;$i<sizeof($columns);$i++)
      {
        $col_list[]=$columns[$i];
        $i++;
      }
      sort($col_list);

      $result=$result->fetchRow(DB_FETCHMODE_ORDERED);
?>
<script>
function f(number)
{
  document.form.elements[number].select();
  temp=parseInt(document.form.elements[number].value);
  if(!isNaN(temp))
    document.form.elements[number].value=temp;
  return temp;
}
function checkForm()
{
  ip=f(1);
  if(isNaN(ip) || ip<100)
  {
    alert('This is not a number, or it is too small !');
    return false;
  }
  rp=f(2)
  if(isNaN(rp) || rp<100)
  {
    alert('This is not a number, or it is too small !');
    return false;
  }
  if(rp<ip)
  {
    alert('Reserve price is lower than initial price !');
    return false;
  }
  if(isNaN(f(3)) || f(3)>30 || f(3)<1)
  {
    alert('This is not a number or is too big !');
    return false;
  }
  return true;
}
</script>
<?php    echo "
      <table cellpadding='1' cellspacing='0'> 
      <tr> 
        <td align='center' valign='middle' class='Form_Cadre_title'> Please enter the sale details for <b>$result[0]</b> (ISBN ".isbn($isbn).")</td>
      </tr>
      <tr>
        <td class='Form_Cadre_main' align='center'>
        <br><br>
        <form name=form action=index.php?do=sell_book&isbn=$isbn$sess_id method=post onsubmit='return checkForm()'>
        <table width=500>
        <tr>
          <td align=right valign=middle width=250>Book condition: &nbsp;</td>
          <td align=left valign=top width=250>
            <select class=inputT name=form_cond>";
            for($i=0;$i<sizeof($col_list);$i++){
            echo "<option value='$col_list[$i]'>$col_list[$i]\n";}
        echo "</select></td></tr>
        <tr>
          <td align=right valign=middle>Initial price: &nbsp;</td>
          <td align=left valign=top>
          <input class=inputT type=text name=form_init_p size=10 maxlength=32> (in pennies)
          </td>
        </tr>
        <tr>
          <td align=right valign=middle>Reserve price: &nbsp;</td>
          <td align=left valign=top>
          <input class=inputT type=text name=form_res_p size=10 maxlength=32> (in pennies)
          </td>
        </tr>
        <tr>
          <td align=right valign=middle>Sell for how many days? &nbsp;</td>
          <td align=left valign=top>
          <input class=inputT type=text name=form_days size=20 maxlength=10>
          </td>
        </tr>
        </table>
        <input name='submit' type='image' value=Submit src='images/submit.jpg'>
        <br>
        </form>
        </td></tr></table>
        <br><br>
        Note that when the sale will be over, your BUCS e-mail address and your telephone number will be transmitted to the winner of the bid.";
    }
    else
    {
      // Unable to read columns...
      echo "Not successful: " . $columns->getMessage();
    }
  }
}
else
{
  // No such book! User should enter it
  include("enter_book.php");
}

?>